/*
 *	Copyright (C) 2007. PARP Research Group.
 *	<http://perception.inf.um.es>
 *	University of Murcia, Spain.
 *
 *	This file is part of the QVision library.
 *
 *	QVision is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU Lesser General Public License as
 *	published by the Free Software Foundation, version 3 of the License.
 *
 *	QVision is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU Lesser General Public License for more details.
 *
 *	You should have received a copy of the GNU Lesser General Public
 *	License along with QVision. If not, see <http://www.gnu.org/licenses/>.
 */

/// @file hello-world.cpp
/// @brief Example program for QVision library. Shows the use of QVApllication and QVWorker classes.
///
/// To use the program, simply compile, and execute the binary:
///
///	./hello-world
///
/// @author PARP Research Group. University of Murcia, Spain.
///

#include <stdio.h>
#include <stdlib.h>
#include <iostream>

#include <qvcore/qvapplication.h>
#include <qvgui/qvisioninterface.h>

class MyWorker: public QVWorker
	{
	public:
		MyWorker(QString name):QVWorker(name) {}
		void worker()
			{
			std::cout << "Worker " <<
				qPrintable(this->getName()) << ", iteration "
				<< this->getIteration() << std::endl;
			}
	};

int main(int argc, char *argv[])
	{
	QVApplication app(argc, argv,
		
		"Example program for QVision library. Shows the use of QVApllication and QVWorker classes."

		);

	MyWorker worker("QVWorker 'Hello world'");

	QVisionInterface interface;

	int status = app.exec();

	return status;
	}
