/*
 *	Copyright (C) 2007. PARP Research Group.
 *	<http://perception.inf.um.es>
 *	University of Murcia, Spain.
 *
 *	This file is part of the QVision library.
 *
 *	QVision is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU Lesser General Public License as
 *	published by the Free Software Foundation, version 3 of the License.
 *
 *	QVision is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU Lesser General Public License for more details.
 *
 *	You should have received a copy of the GNU Lesser General Public
 *	License along with QVision. If not, see <http://www.gnu.org/licenses/>.
 */

/// @file qvpolyline.h
/// @brief File from the QVision library.
/// @author PARP Research Group. University of Murcia, Spain.

#ifndef QVPOLYLINE_H
#define QVPOLYLINE_H

#include <qvipp/qvipp.h>
#include <qvcore/qvimage.h>

/// \cond Not documented By now
class QVPolyline: public QList<QPoint>
	{
	public:
		bool loop, direction;
		int dir;

		QVPolyline();
		QVPolyline(const QVPolyline &polyline);

		static QVPolyline ellipse(uInt n, float x, float y, float maxRadio, float minRadio, float ang);
		static QVPolyline line(int x1, int y1, int x2, int y2);
		static QVPolyline rectangle(int x1, int y1, int x2, int y2);
	};

void draw(QVImage<uChar> &image, const QVPolyline &polyline, uChar constant, bool linked=FALSE, bool safe=FALSE);
void draw(QVImage<uChar,3> &image, const QVPolyline &polyline, uChar constant[3], bool linked=FALSE, bool safe=FALSE);
void draw(QVImage<uChar> &img, const QList< QVPolyline > &polylineList, uChar constant, bool linked=FALSE, bool safe=FALSE);
void draw(QVImage<uChar,3> &img,const QList< QVPolyline > &polylineList, uChar constant[3],bool linked=FALSE,bool safe=FALSE);

void drawPoints(const QList<QPoint> &hotPoints, QVImage<uChar> &dest);
void drawPoints(const QList<QPoint> &hotPoints, QVImage<uChar,3> &dest);


/// \endcond Not documented By now
#endif

